<?php

class Dataentry extends Controller{

    function Dataentry()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      global $databaseName;
      $databaseName = $this->session->userdata('selectedPlotName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function formname()
    {
       $data['title'] = "Data Entry";
       $data['contentTitle'] = "Select Form Name";
       $data['formHeading'] = "";
       $data['formOpen'] = form_open("dataentry/formnamevalidate");
       $data['table'] = $this->_selectFormNameTable();
       $data['backLink'] = "";
       $this->load->view('forms/simpleform',$data);
    }

    function formnamevalidate()
    {
      global $databaseName;

      $this->_validateFormName('dropDown');
      $formName = $this->input->post('formNameDD');

      if($this->form_validation->run() == FALSE)
      {
        $data['title'] = "Data Entry";
        $data['contentTitle'] = "Select Form Name";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("dataentry/formnamevalidate");
        $data['backLink'] = "";
        $data['table'] = $this->_selectFormNameTable();
        $this->load->view('forms/simpleform',$data);
      }

      else
      {
        $this->session->set_userdata('formName',$formName);
        redirect('dataentry/mainmenu');
      }

    }

    function _selectFormNameTable()
    {
      global $databaseName;
        $dir = "./files/configfiles/";

        if(is_dir($dir))
        {
          if ($dh = opendir($dir))
          {
            $formNameArray = array();
            //$fileNameArray['default'] = 'No Files In Folder';
            while (($file = readdir($dh)) !== false)
            {
              if($file !== "." && $file !== "..")
              {
                $fileSplit = explode(".",$file);
                $file = $fileSplit[0]; // Remove .txt from the end - need to remove for dropdown
                $fileSplit1 = explode("_",$file);
                if($fileSplit1[1] == $databaseName)
                {
                  $formNameArray[$fileSplit1[0]] = $fileSplit1[0];
                }
                //$fileNameArray['default'] = 'Select';
              }
            }
            natcasesort($formNameArray);
            $defaultArray = array('default'=>'Select');
            $formNameArray = array_merge($defaultArray,$formNameArray);
            closedir($dh);
          }
       }
       else
       {
         $formNameArray = array('default'=>'No Directory');
       }

       $formName = set_value('formNameTbx');



      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');


      $formNameDD = form_dropdown('formNameDD',$formNameArray);
      $submitButton = form_button($submitButtonA);

      $formNameDDErr = form_error('formNameDD');

      $formTableA = array(array(),
                          array('Select Form : ',$formNameDD,$formNameDDErr),
                          array('','<p style="text-align:center;">'.$submitButton.'</p>')
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

  function _validateFormName($columnType)
  {
    if($columnType == 'dropDown')
    {
      $this->form_validation->set_rules('formNameDD', 'Form Name', 'callback_dropdown_check');
    }
    else
    {
      $this->form_validation->set_rules('formNameTbx', 'Form Name', 'required|max_length[40]');
    }
    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }


    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }


    function mainmenu()
    {
      if(!isset($this->session->userdata['formName']))
      {
         $this->formname();
      }
      $formName = $this->session->userdata('formName');

      $formTableA = array(array(''),
                          array(anchor('/gdeplantform', 'Entry Form', array('title'=>'Entry Form', 'class'=>'forward'))),
                          array(anchor('/selectmergefile/selectfile', 'Add More Data Into Existing File', array('title'=>'Add More Data Into Existing File', 'class'=>'forward'))),
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);


      $data['title'] = 'CTFS Generic Data Entry';
      $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }



    function uploaddata()
    {
      if(!isset($this->session->userdata['formName']))
      {
         $this->formname();
      }
      $formName = $this->session->userdata('formName');
      $formTableA = array(array(''),
                          array(anchor('/gdedataupload/uploadall', 'Upload all the Files for this form', array('title'=>'Upload All Files', 'class'=>'forward', 'onclick'=>"return confirm('Are you sure you want to upload all data for this form?')"))),
                          array(anchor('/gdedataupload/uploadselect', 'Select a file to Upload', array('title'=>'Upload Selected File', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $data['title'] = 'CTFS Generic Data Entry';
      $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }



    function datascreening()
    {
      if(!isset($this->session->userdata['formName']))
      {
         $this->formname();
      }
      $formName = $this->session->userdata('formName');

      $formTableA = array(array(''),
                          array(anchor('/doublescreening/tableselect', 'Compare Data in Temporary Tables', array('title'=>'Compare Data in Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/dataview/tableselect', 'View all the Screened Records in Temporary Tables', array('title'=>'View all the Records in Temporary Tables', 'class'=>'forward'))),
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $data['title'] = 'CTFS Generic Data Entry';
      $data['contentTitle'] = 'Select Data Screening Type - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.'</span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }



    function doubledataentry()
    {
      if(!isset($this->session->userdata['formName']))
      {
         $this->formname();
      }
      $formName = $this->session->userdata('formName');

      $formTableA = array(array(''),
                          array(anchor('/doublescreening/tableselect', 'Compare Data in Temporary Tables', array('title'=>'Compare Data in Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/dataview/selectformtype', 'View all the Screened Records in Temporary Tables', array('title'=>'View all the Records in Temporary Tables', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);


      $data['title'] = 'CTFS Generic Data Entry';
      $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.'</span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }



    function fileExists($path)
    {
      return (@fopen($path,"r")==true);
    }


}